diff -urN ruby-gimp-0.5.0/ChangeLog ruby-gimp-0.5.1/ChangeLog
--- ruby-gimp-0.5.0/ChangeLog	Mon Jul  9 06:05:33 2001
+++ ruby-gimp-0.5.1/ChangeLog	Wed Jul 11 04:21:43 2001
@@ -1,3 +1,13 @@
+Jul 10th 2001 - Masahiro Sakai <s01397ms@sfc.keio.ac.jp>
+
+	* gimp/lib/gimp/object-id.rb:
+	    Layer#method_missing: fixed fatal bug.
+
+Jul 9th 2001 - Masahiro Sakai <s01397ms@sfc.keio.ac.jp>
+	
+	* gimp/lib/gimp/*: restruct file compositions, for dRuby.
+
+
 Jul 8th 2001 - Masahiro Sakai <s01397ms@sfc.keio.ac.jp>
 
 	* gck/extconf.rb
diff -urN ruby-gimp-0.5.0/gimp/lib/gimp/object-id.rb ruby-gimp-0.5.1/gimp/lib/gimp/object-id.rb
--- ruby-gimp-0.5.0/gimp/lib/gimp/object-id.rb	Mon Jul  9 22:55:43 2001
+++ ruby-gimp-0.5.1/gimp/lib/gimp/object-id.rb	Wed Jul 11 03:41:00 2001
@@ -197,17 +197,16 @@
     def method_missing(msg_id, *args)
       CheckSanity()
       method_name = msg_id.id2name
-      proc_name = nil
       proc = nil
 
       if Boolean(PDB["gimp_layer_is_floating_sel"].call(self))
 	tmp = PDB["gimp_floating_sel_" + method_name]
-	proc = tmp if tmp and proc.args[0].type == PDB_LAYER
+	proc = tmp if tmp and tmp.args[0].type == PDB_LAYER
       end
 
-      unless proc_name
+      unless proc
 	tmp = PDB["gimp_layer_" + method_name]
-	proc = tmp if tmp and proc.args[0].type == PDB_LAYER
+	proc = tmp if tmp and tmp.args[0].type == PDB_LAYER
       end
 
       unless proc
diff -urN ruby-gimp-0.5.0/gimp/rbgimpdrawable.c ruby-gimp-0.5.1/gimp/rbgimpdrawable.c
--- ruby-gimp-0.5.0/gimp/rbgimpdrawable.c	Mon Jul  9 22:38:57 2001
+++ ruby-gimp-0.5.1/gimp/rbgimpdrawable.c	Tue Jul 10 21:41:06 2001
@@ -53,7 +53,7 @@
 GimpDrawable* rbgimp_drawable_get_struct(VALUE obj)
 {
     GimpDrawable* result;
-    if (rb_obj_is_kind_of(obj, rbgimp_cDrawableID))
+    if (rb_obj_is_kind_of(obj, rbgimp_cDrawable))
         rb_raise(rb_eTypeError, "not a %s", "Gimp::CDrawable");
     Data_Get_Struct(obj, GimpDrawable, result);
     return result;
@@ -67,17 +67,6 @@
 }
 
 static
-VALUE drawable_test_equal(VALUE self, VALUE rhs)
-{
-    if (!rb_obj_is_kind_of(rhs, rbgimp_cDrawable) &&
-        (rbgimp_drawable_get_struct(self)->id ==
-         rbgimp_drawable_get_struct(rhs)->id))
-        return Qtrue;
-    else
-        return Qfalse;
-}
-
-static
 VALUE drawable_flush(VALUE self)
 {
     gimp_drawable_flush(rbgimp_drawable_get_struct(self));
@@ -185,7 +174,6 @@
     //
 
     rbgimp_cDrawable = rb_define_class_under(mGimp, "CDrawable", rb_cObject);
-    rb_define_method(rbgimp_cDrawable, "==", &drawable_test_equal, 1);
     rb_define_method(rbgimp_cDrawable, "flush", &drawable_flush, 0);
     rb_define_method(rbgimp_cDrawable, "get_tile", &drawable_get_tile, 3);
     rb_define_method(rbgimp_cDrawable, "get_tile2", &drawable_get_tile2, 3);
